Attribute VB_Name = "mCreateDisk"
Option Explicit

'===============================================================================
'This module was written by Fahad Khowaja (fahadkhowaja@hotmail.com). Visit the
'website at http://www28.brinkster.com/win98xpsdc for latest info.
'
'The modification of the DeviceIoControl, WriteFile and CreateFile functions was
'based on code written by Arkadiy Olovyannikov (ark@fesma.ru).
'===============================================================================

'Universal Constants defined for use in Visual Basic
'---------------------------------------------------
Private Const VWIN32_DIOC_DOS_INT26 = 3             'Int26 - Direct Write Command
Private Const GENERIC_WRITE As Long = &H40000000    'Type of access requested by CreateFile()
Private Const OPEN_EXISTING As Long = 3             'Creation behaviour for CreateFile()
Private Const INVALID_HANDLE_VALUE As Long = -1     'Some error in getting handle for A:
Private Const MAX_PATH As Long = 260                'Max length of path

'Constants defined by me
'-----------------------
Private Const IS_NATIVE As Boolean = True           'XP is running on the system
Private Const IS_NOT_NATIVE As Boolean = False      'XP is not running on the system
Private Const SHARE_NONE As Long = 0                'Value for no sharing in CreateFile
Private Const NULL_VALUE As Long = &H0              'Null value for functions
Private Const BYTES_PER_SECTOR As Long = 512        'Bytes per sector of floppy
Private Const DRIVE_A As Long = 0                   'reg_EAX value
Private Const NUM_SECTORS_TO_WRITE As Long = 1      'reg_ECX value
Private Const SECTOR_TO_START As Long = 0           'reg_EDX value

'This is required by DeviceIoControl(). I found that the meaning of each register
'depends on the command it is being used with. Here, with the VWIN32_DIOC_DOS_INT26
'command:
'EAX - Drive type (0-A,1-B,2-C,...)
'EBX - Pointer to a buffer that will store the data to be written
'ECX - Number of sectors to write
'EDX - Sector number to start writing from
'ESI - NO IDEA!! I searched a lot but couldn't find!
'If anyone knows more about them or a resource which has info on them,
'please email me at fahadkhowaja@hotmail.com! Will be very grateful!
'---------------------------------------------------------------------
Private Type DIOC_REGISTER
  reg_EBX As Long
  reg_EDX As Long
  reg_ECX As Long
  reg_EAX As Long
  reg_EDI As Long
  reg_ESI As Long
  reg_Flags As Long
End Type

'A note about the functions that follow:
'--------------------------------------
'The Definition of CreateFile, DeviceIoControl and Write File as given in the Visual
'Basic API viewer mentions arguments of type OVERLAPPED and SECURITY_ATTRIBUTES.
'But since I am not passing any values for those arguments I tried to pass the
'NULL value ie 0 or 0& or &H0. But all these values resulted in errors. I finally
'changed the type for arguments that had the above two types to Long and pass ByVal.
'I had seen this to work in a lot of code written earlier by others. And voila! that
'was what happened. After changing the types to Long ByVal everything worked fine
'and I could pass the usual NULL value without any errors.
'
'But it seems strange that it is possible to change the definition of an API
'function and then pass it values it doesnt expect and it works fine. I think
'I am not doing this the proper way, so if anyone knows how this is supposed to
'work actually then please email me at fahadkhowaja@hotmail.com. Will be grateful!
'----------------------------------------------------------------------------------

'Function required to write to floppy in Win9x
'---------------------------------------------
Private Declare Function DeviceIoControl Lib "kernel32.dll" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, lpInBuffer As Any, ByVal nInBufferSize As Long, lpOutBuffer As Any, ByVal nOutBufferSize As Long, lpBytesReturned As Long, ByVal lpOverlapped As Long) As Long

'Function required to write to floppy in WinNT/XP
'------------------------------------------------
Private Declare Function WriteFile Lib "kernel32.dll" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long

'This functions returns a handle to A: which is used by the above functions
'--------------------------------------------------------------------------
Private Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long

'This one closes the handle opened by CreateFile
'-----------------------------------------------
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long

'This function retrieves the windows directory
'---------------------------------------------
Private Declare Function GetWindowsDirectory Lib "kernel32.dll" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long


'==========================================================================
'This function decides checks what type (Win98 or WinXP) of disk is being
'created and on which OS and transfers control to the appropriate function.
'==========================================================================

Public Function CreateDisk(ByVal sTargetOS As String) As Boolean

Select Case sWinType
    'Working on win98
    '----------------
    Case "9x"
        If sTargetOS = "98" Then
            CreateDisk = Copy98Files()
        Else
            If WriteBootSector("XP") Then
                CreateDisk = CopyXPFiles(IS_NOT_NATIVE)
            Else
                CreateDisk = False
            End If
        End If
    'Working on WinNT types OS
    '-------------------------
    Case "NT"
        If sTargetOS = "XP" Then
           CreateDisk = CopyXPFiles(IS_NATIVE)
        Else
            If WriteBootSector("98") Then
                CreateDisk = Copy98Files()
            Else
                CreateDisk = False
            End If
        End If
End Select
           
End Function

Private Function Copy98Files() As Boolean

Dim i As Integer, sPath As String, sSourceFile As String
Dim sTargetFile As String
Dim asFiles98 As Variant

On Error GoTo cath_error

asFiles98 = Array("Aspi2dos.sys", "Aspi4dos.sys", "Aspi8dos.sys", "Aspi8u2.sys", _
                  "Aspicd.sys", "Autoexec.bat", "Btcdrom.sys", "Btdosm.sys", _
                  "Command.com", "Config.sys", "Drvspace.bin", "Ebd.cab", _
                  "Ebd.sys", "Extract.exe", "Fdisk.exe", "Findramd.exe", _
                  "Flashpt.sys", "Himem.sys", "Io.sys", "Msdos.sys", _
                  "Oakcdrom.sys", "Ramdrive.sys", "Readme.txt", "Setramd.bat")

sPath = App.Path & "\Data\Win98\Files\"

frmMain.Label6.Caption = "Copying files..."

'I dont know why after the disk is formatted and this functions starts to copy
'files, I get error 75: Path/File Access Error. Somehow it seems that after the
'format this function can't find A: No idea why this happens; if somebody has
'then please email me at fahadkhowaja@hotmail.com. Will be grateful.
'
'I worked around the problem by refreshing the A: by trying to access it
'using a Dir("a:\"). This does the trick but I'm still not satisfied so if anyone
'knows why this behaviour occurs please enlighten me!

Dir "a:\"

For i = LBound(asFiles98) To UBound(asFiles98)
    sSourceFile = sPath & asFiles98(i)
    sTargetFile = "a:\" & asFiles98(i)
    FileCopy sSourceFile, sTargetFile
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + 1
    frmMain.Refresh
Next i

Call SetAttributes98

Copy98Files = True

Exit Function

cath_error:
Dim sErrMsg As String
sErrMsg = "Could not write to disk!" & vbCrLf & "Check that the disk is not write protected."
MsgBox sErrMsg, vbApplicationModal + vbCritical + vbOKOnly, "Disk Write Error!"
Copy98Files = False

End Function

Private Function CopyXPFiles(ByVal bIsNative As Boolean) As Boolean

Dim sPath As String, i As Integer
Dim asFilenames As Variant, sSourceFile As String, sTargetFile As String

asFilenames = Array("ntldr", "ntdetect.com", "boot.ini")

frmMain.Label6.Caption = "Copying files..."
frmMain.Refresh

If bIsNative = IS_NATIVE Then
    sPath = WinDrive()
    If sPath = "" Then CopyXPFiles = False: Exit Function
Else
    sPath = App.Path & "\Data\WinXP\Files\"
End If

'Same reason as above
'--------------------
Dir "a:\"

For i = LBound(asFilenames) To UBound(asFilenames)
    sSourceFile = sPath & asFilenames(i)
    sTargetFile = "a:\" & asFilenames(i)
    FileCopy sSourceFile, sTargetFile
    frmMain.ProgressBar1.Value = frmMain.ProgressBar1.Value + 1
    frmMain.Refresh
Next i

Call SetAttributesXP

CopyXPFiles = True

Exit Function

cath_error:
Dim sErrMsg As String
sErrMsg = "Could not write to disk!"
MsgBox sErrMsg, vbApplicationModal + vbCritical + vbOKOnly, "Disk Write Error!"
CopyXPFiles = False

End Function

'==================================================================================
'This subroutine sets the attributes of Win 98 system files to hidden and read-only
'==================================================================================

Private Sub SetAttributes98()

Dim i As Integer, asFilenames As Variant

asFilenames = Array("io.sys", "msdos.sys", "ebd.sys")

For i = LBound(asFilenames) To UBound(asFilenames)
    SetAttr "a:\" & asFilenames(i), vbHidden + vbReadOnly + vbSystem
Next i

End Sub

'===============================================================================
'This function sets the attributes of WinXP system files to hidden and read-only
'===============================================================================

Private Sub SetAttributesXP()

Dim i As Integer, asFilenames As Variant

asFilenames = Array("ntldr", "ntdetect.com", "boot.ini")

For i = LBound(asFilenames) To UBound(asFilenames)
    SetAttr "a:\" & asFilenames(i), vbHidden + vbSystem + vbReadOnly
Next i
    
End Sub

'=====================================================================
'This function writes the boot sector of the OS version it receives in
'WriteBSofOSVer to the floppy.
'=====================================================================

Private Function WriteBootSector(ByVal WriteBSofOSVer As String) As Boolean

Dim hDevice As Long
Dim lBytesWritten As Long
Dim abBootSector(511) As Byte                   'Byte array to store Boot Sector
Dim iFile As Integer
Dim retValue As Long
Dim sPath As String

iFile = FreeFile()

If WriteBSofOSVer = "98" Then
    sPath = App.Path & "\Data\Win98\BS\Win98BS.bs"
    
    'Reading the boot sector from file
    '-----------------------------------
    Open sPath For Binary As #iFile
        Get #iFile, , abBootSector()
    Close #1
    
    'Accessing the A: drive
    '----------------------
    hDevice = CreateFile("\\.\A:", GENERIC_WRITE, SHARE_NONE, NULL_VALUE, OPEN_EXISTING, NULL_VALUE, NULL_VALUE)
    If Not TestHandle(hDevice) Then WriteBootSector = False: Exit Function
    
    'Writing the boot sector
    '-----------------------
    retValue = WriteFile(hDevice, abBootSector(0), BYTES_PER_SECTOR, lBytesWritten, NULL_VALUE)
    If Not TestBSWrite(retValue) Then WriteBootSector = False: Exit Function
    
    'Closing A: drive
    '----------------
    CloseHandle hDevice
    
Else
    
    Dim reg As DIOC_REGISTER
    
    With reg
        .reg_EAX = DRIVE_A
        .reg_EBX = VarPtr(abBootSector(0))
        .reg_ECX = NUM_SECTORS_TO_WRITE
        .reg_EDX = SECTOR_TO_START
        .reg_ESI = &H6000
    End With
    
    sPath = App.Path & "\Data\WinXP\BS\WinXPBS.bs"
    
    'Reading the boot sector from file
    '-----------------------------------
    Open sPath For Binary As #iFile
        Get #iFile, , abBootSector()
    Close #1

    hDevice = CreateFile("\\.\VWIN32", GENERIC_WRITE, SHARE_NONE, NULL_VALUE, OPEN_EXISTING, NULL_VALUE, NULL_VALUE)
    If Not TestHandle(hDevice) Then WriteBootSector = False: Exit Function
    
    retValue = DeviceIoControl(hDevice, VWIN32_DIOC_DOS_INT26, reg, Len(reg), reg, Len(reg), lBytesWritten, NULL_VALUE)
    If Not TestBSWrite(retValue) Then WriteBootSector = False: Exit Function
    
    CloseHandle hDevice
    
End If

WriteBootSector = True

End Function

'=====================================================================
'This function tests the hDevice value returned by CreateFile to check
'whether it is valid or not.
'=====================================================================

Private Function TestHandle(ByVal hDevice As Long) As Boolean

If hDevice = INVALID_HANDLE_VALUE Then
    MsgBox "Unable to get a handle for the floppy drive.", vbApplicationModal + vbCritical + vbOKOnly, "Disk Access Error!"
    TestHandle = False
    Exit Function
End If

TestHandle = True

End Function

'========================================================================
'This function checks the value returned by DeviceIoControl and WriteFile
'to check whether they were able to write the boot sector successfully or
'some error occurred.
'========================================================================

Private Function TestBSWrite(ByVal retValue As Long) As Boolean

If retValue = 0 Then
    MsgBox "Unable to write boot sector to floppy.", vbApplicationModal + vbCritical + vbOKOnly, "Disk Write Error!"
    TestBSWrite = False
    Exit Function
End If

TestBSWrite = True

End Function

'===================================================================
'This function returns the root drive in which windows is installed.
'===================================================================

Private Function WinDrive() As String

Dim sWinPath As String * MAX_PATH
Dim lRetValue As Long

lRetValue = GetWindowsDirectory(sWinPath, MAX_PATH)

If lRetValue = 0 Then
    MsgBox "Error finding windows directory.", vbApplicationModal + vbCritical + vbOKOnly, "Error!"
    WinDrive = ""
    Exit Function
End If

WinDrive = Left$(sWinPath, 3)

End Function
