Attribute VB_Name = "mFormat"
Option Explicit

'===================================================================================
'This module was written by Fahad Khowaja (fahadkhowaja@hotmail.com). Visit the
'website at http://www28.brinkster.com/win98xpsdc for latest info.
'
'This module is a modified version of code written by Kenneth Ives (kenaso@attbi.com)
'for http://www.freevbcode.com/
'===================================================================================

'Constants for file handling
'---------------------------
Public Const FL_FORMAT_BAT = "formatDisk.bat"       'MSDOS Batch file for format
Private Const FL_FORMAT_KEY = "formatDisk.key"      'Key file to answer format prompts
Private Const FL_TEST = "a:\test.dat"               'File to test if A:\ is writable

'API function to get temporary folder
'------------------------------------
Private Declare Function GetTempPath Lib "kernel32.dll" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

'=============================================================================
'This function creates the batch files which are required to format the floppy
'One MSDOS batch file contains the commands to format a disk while the other
'file contains the answers to the format prompts.
'=============================================================================

Public Function CreateBatchFile() As Boolean

On Error GoTo BatchError

Dim iFile As Integer

iFile = FreeFile                                    'Find the first free file slot

'Writing the MSDOS batch file which will perform the format
'----------------------------------------------------------
Open FL_FORMAT_BAT For Output As #iFile
Print #iFile, "@echo off"
Print #iFile, "format a: /q/x/v:WIN98XPSDC/u<" & FL_FORMAT_KEY
Print #iFile, "del formatDisk.key"
Print #iFile, "del formatDisk.bat"
Close #iFile

'Writing the key file that will answer format prompts
'----------------------------------------------------
Open FL_FORMAT_KEY For Output As #iFile
Print #iFile, vbCrLf & "n" & vbCrLf
Close #iFile

CreateBatchFile = True

Exit Function

BatchError:
MsgBox Err.Number & vbCrLf & Err.Description & vbCrLf & Err.Source, vbApplicationModal + vbCritical + vbOKOnly, "Batch File Error"
CreateBatchFile = False

End Function

'==============================================================================
'This subroutine uses the Win32 API function GetTempPath to find the directory
'for temporary files and sets the current working directory to that.
'==============================================================================

Public Sub SetTempDir()

Dim sTempDir As String

sTempDir = String(100, Chr(0))                      '100 char long string filled with NULL

'Finding and changing to the temp directory
'------------------------------------------
GetTempPath 100, sTempDir
sTempDir = Left$(sTempDir, InStr(sTempDir, Chr$(0)) - 1)
ChDrive (Left$(sTempDir, 2))
ChDir (sTempDir)

End Sub

'=====================================================================================
'This function determines whether the floppy disk can be properly read and written to.
'It does this by first trying to read a directory from the disk for read testing and
'then trying to write a test file to the disk for write testing.
'=====================================================================================

Public Function IsDriveReady() As Boolean

On Error Resume Next

Dim sErrMsg As String

'Testing whether the disk can be read
'------------------------------------
Dir "a:\", vbDirectory

If Err.Number <> 0 Then
    sErrMsg = "Cannot read from the floppy drive. The disk may be damaged." & vbCrLf & "Please replace the disk."
    MsgBox sErrMsg, vbOKOnly + vbApplicationModal + vbCritical, "Disk Error"
    IsDriveReady = False
    Exit Function
End If

'Testing whether the disk can be written to
'------------------------------------------
Open FL_TEST For Output As #1

If Err.Number <> 0 Then
    sErrMsg = "Unable to write to disk." & vbCrLf & "The disk may be full or write protected."
    MsgBox sErrMsg, vbApplicationModal + vbOKOnly + vbCritical, "Disk Error"
    IsDriveReady = False
    Close #1
    Exit Function
End If

Close #1

IsDriveReady = True

End Function

'===============================================================================
'This subroutine runs the program whose filename is received. The Do loop makes
'sure that the format program has finished before it returns control back. This
'is done because formatting a floppy takes time and before it is complete no
'calls should be made to the disk.
'===============================================================================

Public Sub RunDOSShell(ByVal sFilename As String)

Shell sFilename, vbHide                              'Run the batch file

'Make sure that formatting has fininshed!
'----------------------------------------
Do
    If FileExists(FL_FORMAT_BAT) Then
        Call Delay(3)
    Else
        Exit Do
    End If
Loop

End Sub

'===============================================================================
'This function checks whether a file exits. If it does it returns true other it
'returns false.
'===============================================================================

Public Function FileExists(ByVal sFilename As String) As Boolean

FileExists = IIf(Dir(sFilename) = "", False, True)

End Function

'=================================================================================
'This subroutine creates a delay of iDelayBySecs seconds. It does so by adding the
'number of secs to delay to the time at which it is called and then checking when
'the present time exceeds this delayed time. The DoEvents statement allows other
'processing to continue during the delay to prevent a system freeze.
'=================================================================================

Public Sub Delay(ByVal iDelayBySecs As Integer)

Dim dtDelayTime As Date

dtDelayTime = DateAdd("s", iDelayBySecs, Now)           'Add num of secs to delay to present time

'Check when the present time exceeds the delayed time
'----------------------------------------------------
While Now < dtDelayTime
    DoEvents
Wend

End Sub
